from Spectacle import Spectacle
from Representation import Representation
import sqlite3

from Interface_texte import Interface_texte
from Interface_ipywidgets import Interface_graphique

class CTRL_cons_rep:
    def __init__(self,interface, sgbd):
        '''Crée un objet qui est un contrôleur des consultations de spectacles.
        Le paramètre est le type d'interface que le controleur va utiliser.'''
        self.bd = sqlite3.connect('gestion_spectacle.db')
        Spectacle.init_class(self.bd)
        Representation.init_class(self.bd)
        if interface == 'graphique':
            self.interface = Interface_graphique(self)
        else:
            self.interface = Interface_texte(self)
        self.interface.top_menu()
    def dde_con_rep(self):
        '''Permet d'initier le choix d'un spectacle'''
        #print('demande')
        lst = Spectacle.infos_spectacle()
        self.interface.afficher_choix_spectacle(lst)
    def valider_choix_spectacle(self,obj_spec):
        '''Permet de prendre en compte le choix d'un spectacle. Le paramètre
        obj_spec est le spectacle choisi.'''
        print('valider  ',obj_spec)
        lst = obj_spec.infos_rep_et_dispo()
        self.interface.afficher_representations(lst)
    def fin_consultation(self):
        '''Méthode appelée lors de la fin de la consultation de représentations'''
        self.interface.top_menu()
