import ipywidgets as widgets
from IPython.display import display
from functools import partial


class Interface_graphique:
    def __init__(self,controler):
        '''Crée un objet interface graphique tkinter.'''
        self.out = widgets.Output()
        self.controler  = controler
        self.liste_spectacles = None
        display(self.out)
    def afficher_choix_spectacle(self,spclst):
        '''Affiche la liste des spectacles spclst. Les deux derniers paramètres
        sont des callbacks, le premier pour une interruption de consultation, 
        le second pour exprimer le choix d'un spectacle dont les représentations
        seront consultées.'''
        self.liste_spectacles = spclst
        lig = 0
        hboxitems = []
        prem = spclst[0].info_spectacle()
        for key in prem.keys():
            hboxitems.append([widgets.Label(key)])
        hboxitems.append([widgets.Label()])
        for spec in spclst:
            infos = spec.info_spectacle()
            col = 0
            for val in infos.values():
                hboxitems[col].append(widgets.Label(val))
                col += 1
            button = widgets.Button(description='choisir '+str(lig))
            button.on_click(self.__choisir)
            hboxitems[col].append(button)
            lig += 1
        button =  widgets.Button(description="retour")
        button.on_click(self.__quit_list)
        hboxitems[0].append(button)
        self.out.clear_output()
        with self.out:
            hbox = widgets.HBox([widgets.VBox(x) for x in hboxitems])
            display(hbox)
    def afficher_representations(self,replst):
        '''Affiche la liste de représentation replst. Cet affichage se poursuit
        jusqu'à l'appel du callback fin_consultation.'''
        prem = replst[0].infos_rep()
        hboxitems = []
        for key in prem.keys():
            hboxitems.append([widgets.Label(key)])
        hboxitems.append([widgets.Label()])
        lig=0
        for spec in replst:
            infos = spec.infos_rep()
            print(infos)
            col = 0
            for st in infos.values():
                #print('st '+st)
                hboxitems[col].append(widgets.Label(str(st)))
                col += 1
            lig += 1
        button =  widgets.Button(description="fin de consultation")
        button.on_click(self.__quit_list)
        hboxitems[0].append(button) 
        self.out.clear_output()
        with self.out:
            display(widgets.HBox([widgets.VBox(x) for x in hboxitems]))
    def top_menu(self):
        '''Affiche un menu permettant d'accéder à toutes les opérations
        accessibles à une personne ayant le statut de client.'''
        vboxitems = []
        button = widgets.Button(description="Consulter des représentation")
        button.on_click(self.__consulter_representations)
        vboxitems.append(button)
        button = widgets.Button(description="Acheter un abonnement")
        button.on_click(self.__not_yet_implemented)
        vboxitems.append(button)
        button = widgets.Button(description="Acheter des billets")
        button.on_click(self.__not_yet_implemented)
        vboxitems.append(button)
        button = widgets.Button(description="Quitter l'application")
        button.on_click(self.quit)
        vboxitems.append(button)
        #print(hboxitems)
        vbox = widgets.VBox(vboxitems)
        self.top_menu = vbox
        self.out.clear_output()
        with self.out:
            display(vbox)
    def quit(self,button):
        '''Quitte l'interface et ferme la fenêtre principale.'''
        self.out.clear_output()
        with self.out:
            print('au revoir')
    def __not_yet_implemented(self,button) -> None:
        self.out.clear_output()
        self.out.append_stdout("Fonction non encore implémentée")
    def __quit_list(self,button) -> None:
        self.out.clear_output()
        with self.out:
            display(self.top_menu)
    def __choisir(self,button):
        n = int(button.description[-1])
        self.controler.valider_choix_spectacle(self.liste_spectacles[n])
    def __consulter_representations(self,button):
        self.controler.dde_con_rep()

