class Representation:
    db = None
    cursor = None
    @staticmethod
    def init_class(dtbs):
        '''Méthode d'initialisation de la classe qui permet de stocker la 
        connection à la base de données et le cursor utilisé pour toutes les
        requêtes effectuées par les méthodes des instances de Representation.
        Cette méthode statique doit être appelée avant la création d'instances.'''
        Representation.db = dtbs
        Representation.cursor = dtbs.cursor()
    def __init__(self, tup):
        '''Crée un nouvel objet représentant une représentation d\'un spectacle.
        Cet objet contient les données d'une ligne du résultat de la jointure
        des tables REPRESENTATION et SALLE.'''
        (id_repr, id_spec, date, heure_debut, heure_fin, nb_places_reservees, nom_salle, nb_places) = tup
        self.id_repr = id_repr
        self.id_spec = id_spec
        self.date = date
        self.heure_debut = heure_debut
        self.heure_fin = heure_fin
        self.nb_places_reservees = nb_places_reservees
        self.nom_salle = nom_salle
        self.nb_places = nb_places
    def nb_places_dispo(self):
        '''Renvoie le nombre de places disponibles pour la représentation'''
        Representation.cursor.execute('select nb_place from SALLE where ' +
                                   ' nom = ' + self.nom_salle)
        nb = int(Representation.cursor.fetchall()[0][0])
        Representation.cursor.execute('select self.nb_places_reservees from ' +
                                   'REPRESENTATION where id_repr = ' +
                                   self.id_repr)
        self.nb_places_reservees = Representation.cursor.fetchall()[0][0]
        return nb-int(self.nb_places_reservees)
    def maj_nb_places(self,nb):
        '''Opération non implémentée'''
        pass
    def infos_rep(self):
        '''Renvoie les informations concernant la représentation sous forme
        d\'un dictionnaire dont les clés sont les noms de colonnes de la 
        table. '''
        return {'date': self.date, 'heure_debut': self.heure_debut,
                'heure_fin': self.heure_fin,
                'nb_places_reservees': self.nb_places_reservees}
    def __str__(self):
        '''Cette méthode renvoie une chaîne représentant la représentation.'''
        return str(self.date) +"\t" + str(self.heure_debut) + "\t" + \
            str(self.nb_places - self.nb_places_reservees) + "\t" + \
            self.nom_salle

