from Representation import Representation

class Spectacle:
    db = None
    cursor = None
    @staticmethod
    def init_class(dtbs):
        '''Méthode d\'initialisation de la classe qui permet de stocker la 
        connection à la base de données et le cursor utilisé pour toutes les
        requêtes effectuées par les méthodes des instances de Spectacle.
        Cette méthode statique doit être appelée avant la création d'instances.'''
        Spectacle.db = dtbs
        Spectacle.cursor = dtbs.cursor()
    @staticmethod
    def infos_spectacle():
        # mais ce type exact pose un problème à pydoc/help
        '''Renvoie la liste de tous les spectacles (une liste d\'instances de
        SPECTACLE'''
        res = []
        Spectacle.cursor.execute("select SPECTACLE.id, nom, date_sortie, avis_presse, avis_public, categorie, duree from SPECTACLE, CATEGORIE where id_categorie=CATEGORIE.id")
        for row in Spectacle.cursor:
            #print('row',row)
            res.append(Spectacle(row))
        print(res)
        return res
    def __init__(self, tup):
        '''Crée une instance de SPECTACLE. Le paramètre tup est un tuple à
        8 positions contenant la clé unique, le nom, la date de sortie, l'avis
        de la presse, l'avis du public, la catégorie et la durée du spectacle.'''
        (id,nom,date_sortie, avis_presse, avis_public,categorie, duree) = tup
        self.id = id
        self.nom = nom
        self.date_sortie = date_sortie
        self.avis_presse = avis_presse
        self.avis_public = avis_public
        self.categorie = categorie
        self.duree = duree
    def ajouter_representations(self,reprlst):
        '''Opération non implémentée'''
        pass
    def infos_rep_et_dispo(self):
        '''Renvoie une liste d'objets de type Representation qui sont
        les représentations du spectacle représenté par l'objet self.'''
        res = []
        Spectacle.cursor.execute("select id_repr, id_spec, date, heure_debut, heure_fin, nb_places_reservees, nom, nb_places from REPRESENTATION, SALLE where id_salle = id AND id_spec = "\
                                 + str(self.id))
        for rep in Spectacle.cursor.fetchall():
            res.append(Representation(rep))
        return res
    def info_spectacle(self):
        '''Renvoie un dictionnaire contenant certaines des données du spectacle
        self'''
        return {'nom' : self.nom, 'date de sortie': self.date_sortie,
               'categorie' : self.categorie, 'duree' : self.duree}
    def __str__(self):
        '''Cette méthode renvoie une chaîne représentant le spectacle.'''
        return self.nom + '\t' + str(self.date_sortie) + '\t' + self.categorie +\
            '\t' + str(self.duree)

        

